Attribute VB_Name = "modMain"
Option Explicit

Public DX                   As DirectX8
Public D3Dx                 As D3DX8

Public Direct3D             As Direct3D8
Public Device               As Direct3DDevice8

Private BoltMain            As New clsLighteningMain

'Land Array
Private Land(3)             As D3DLVERTEX
Private LandIndex(5)        As Integer
Private LandTexture         As Direct3DTexture8
Private SkyBox(5)           As D3DLVERTEX
Private SkyBoxIndex(11)     As Integer
Private SkyBoxTexture       As Direct3DTexture8

'Consts
Private Length_LVertex      As Long
Private Const FVF_LVertex   As Long = (D3DFVF_XYZ Or D3DFVF_DIFFUSE Or D3DFVF_SPECULAR Or D3DFVF_TEX1)
Private Const Pi            As Single = 3.14159265358979


Public Const Length_LineVertex As Long = 16
Public Const FVF_LineVertex As Long = (D3DFVF_XYZ Or D3DFVF_DIFFUSE)
Public Type LineVertex
    x       As Single
    y       As Single
    z       As Single
    Color   As Long
End Type

'Plz Icnore the Spelling Errors in the comments
Public Sub Main()
frmMain.Show
'Set up Direct3D for windowed mode (if this false try setting your DeskTop Color Depth to 16Bit)
InitD3D
If Device Is Nothing Then Exit Sub

InitGeometry

'Main Rendring loop
Do
    If DoEvents() < 1 Then Exit Do 'loop until the user or program closes the window

    Device.BeginScene 'Propare Device for Drawing
    
        'Draw the 2 Tris that make up the land (not to prity but hay it works!)
        Device.SetVertexShader FVF_LVertex
        Device.SetTexture 0, LandTexture
        Device.DrawIndexedPrimitiveUP D3DPT_TRIANGLELIST, 0, 4, 2, LandIndex(0), D3DFMT_INDEX16, Land(0), Length_LVertex
        
        'Draw the "Sky Box" its really not but hay it works (i say that alot)
        Device.SetTexture 0, SkyBoxTexture
        Device.DrawIndexedPrimitiveUP D3DPT_TRIANGLELIST, 0, 6, 4, SkyBoxIndex(0), D3DFMT_INDEX16, SkyBox(0), Length_LVertex
        
        'Add A Bolt at a random XZ evry now and then
        Randomize Timer
        If Rnd > 0.99 Then
            Randomize Timer * Rnd * Timer
            BoltMain.AddBolt (1 - Rnd * 2) * 10, 30, (1 - Rnd * 2) * 37, D3DColorMake(1, 1, 1, 0.5)
        End If
        
        'This is what all this is really for
        'Thats right this is where the Lightening is Rendered!!
        BoltMain.DrawBolts
        
    Device.EndScene 'End Drawing
    
    Device.Present ByVal 0&, ByVal 0&, 0, ByVal 0&
    Device.Clear 0, ByVal 0, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, 0, 1, 0
    DoEvents
Loop

'Clean up
Set Device = Nothing
Set Direct3D = Nothing
Set D3Dx = Nothing
Set DX = Nothing
End
End Sub
Private Sub InitGeometry()
Length_LVertex = Len(Land(0))
'Set up the land

'1+---+2
' |\  |
' | \ |
' |  \|
'4+---+3

With Land(0)
    .x = -47
    .z = 47
    .Color = D3DColorMake(0.2, 0.4, 0.2, 1)
    .tu = 0
    .tv = 0
End With
With Land(1)
    .x = 47
    .z = 47
    .Color = D3DColorMake(0.2, 0.4, 0.2, 1)
    .tu = 5
    .tv = 0
End With
With Land(2)
    .x = 47
    .z = -47
    .Color = D3DColorMake(0.2, 0.4, 0.2, 1)
    .tu = 5
    .tv = 5
End With
With Land(3)
    .x = -47
    .z = -47
    .Color = D3DColorMake(0.2, 0.4, 0.2, 1)
    .tu = 0
    .tv = 5
End With
LandIndex(0) = 0
LandIndex(1) = 1
LandIndex(2) = 2
LandIndex(3) = 0
LandIndex(4) = 2
LandIndex(5) = 3

Set LandTexture = D3Dx.CreateTextureFromFile(Device, App.Path & "\herb2.bmp")

Dim SkyBoxBGcolor0 As Long
SkyBoxBGcolor0 = D3DColorMake(0.61, 0.61, 0.71, 0.71)

'SkyBox
With SkyBox(0)
    .x = -57
    .z = 27
    .Color = SkyBoxBGcolor0
    .tu = 0
    .tv = 1
End With
With SkyBox(1)
    .x = 57
    .z = 27
    .Color = SkyBoxBGcolor0
    .tu = 1
    .tv = 1
End With
With SkyBox(2)
    .x = -57
    .y = 30
    .z = 27
    .Color = SkyBoxBGcolor0
    .tu = 0
    .tv = 0.5
End With
With SkyBox(3)
    .x = 57
    .y = 30
    .z = 27
    .Color = SkyBoxBGcolor0
    .tu = 1
    .tv = 0.5
End With
With SkyBox(4)
    .x = 57
    .y = 50
    .z = 17
    .Color = SkyBoxBGcolor0
    .tu = 1
    .tv = 0
End With
With SkyBox(5)
    .x = -57
    .y = 50
    .z = 17
    .Color = SkyBoxBGcolor0
    .tu = 0
    .tv = 0
End With
SkyBoxIndex(0) = 0
SkyBoxIndex(1) = 2
SkyBoxIndex(2) = 1

SkyBoxIndex(3) = 2
SkyBoxIndex(4) = 3
SkyBoxIndex(5) = 1

SkyBoxIndex(6) = 2
SkyBoxIndex(7) = 4
SkyBoxIndex(8) = 3

SkyBoxIndex(9) = 2
SkyBoxIndex(10) = 5
SkyBoxIndex(11) = 4
Set SkyBoxTexture = D3Dx.CreateTextureFromFile(Device, App.Path & "\sunset.bmp")
End Sub
Private Sub InitD3D()
On Error Resume Next
Set DX = New DirectX8
If DX Is Nothing Then MsgBox "Sorry you must have DX8+ to run this Demo", vbCritical, "ERROR": End
On Error GoTo 0
Set D3Dx = New D3DX8

Set Direct3D = DX.Direct3DCreate()

Dim DevPerms        As D3DPRESENT_PARAMETERS
With DevPerms
    .BackBufferCount = 2
    .BackBufferWidth = 640
    .BackBufferHeight = 480
    .BackBufferFormat = GetConpatibeFormat(0, D3DDEVTYPE_HAL, 16)
    
    .EnableAutoDepthStencil = 1 'True
    .AutoDepthStencilFormat = Get_WBufferFormat(0, D3DDEVTYPE_HAL, .BackBufferFormat) 'Get the WBuffer Format to be used
    If .AutoDepthStencilFormat = 0 Then .EnableAutoDepthStencil = 0 'False
    
    .SwapEffect = D3DSWAPEFFECT_FLIP
    .Windowed = 1 'True
End With
On Error Resume Next
Set Device = Direct3D.CreateDevice(0, D3DDEVTYPE_HAL, frmMain.hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING, DevPerms)
If Device Is Nothing Then MsgBox "There was a error createing the device, Try changing your Desktop Color depth to 16Bit", vbCritical, "Error": Set Direct3D = Nothing: Set DX = Nothing: Set D3Dx = Nothing
On Error GoTo 0
Device.SetRenderState D3DRS_ZENABLE, 2
Device.SetRenderState D3DRS_LIGHTING, 1
Dim Mat As D3DMATERIAL8
Mat.Ambient.a = 1
Mat.Ambient.r = 1
Mat.Ambient.g = 1
Mat.Ambient.b = 1
Device.SetMaterial Mat
Device.SetRenderState D3DRS_AMBIENT, D3DColorMake(0.5, 0.5, 0.5, 0.5)

Device.SetTextureStageState 0, D3DTSS_MAGFILTER, 2
Device.SetTextureStageState 0, D3DTSS_MINFILTER, 2

Device.SetRenderState D3DRS_FOGCOLOR, D3DColorMake(0.25, 0.25, 0.25, 1)
Device.SetRenderState D3DRS_FOGENABLE, True
Device.SetRenderState D3DRS_FOGTABLEMODE, 1
Device.SetRenderState D3DRS_RANGEFOGENABLE, 0
Device.SetRenderState D3DRS_FOGDENSITY, FtoDW(0.05)


Dim Matrix As D3DMATRIX
D3DXMatrixIdentity Matrix
D3DXMatrixPerspectiveFovLH Matrix, Pi / 2, 480 / 640, 1, 75
Device.SetTransform D3DTS_PROJECTION, Matrix

D3DXMatrixIdentity Matrix
D3DXMatrixLookAtLH Matrix, vec3(0, 2, -10), vec3(0, 3, 0), vec3(0, 1, 0)
Device.SetTransform D3DTS_VIEW, Matrix
End Sub
